"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var path = _interopRequireWildcard(require("path"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function createExtensionAllowlistPlugin({
  reason,
  allowedExtensions = ['.js', '.jsx', '.ts', '.tsx']
}) {
  return {
    name: 'extension-allow-list-plugin',

    setup(build) {
      // No lookbehind in Go regexp; need to look at all the files and do the check manually.
      build.onResolve({
        filter: /.*/
      }, args => {
        // Extract the extension; if not in the allow list, return an error.
        const extension = path.extname(args.path);

        if (extension && !allowedExtensions.includes(extension)) {
          const errorReason = reason ? ` Reason: ${reason}` : '';
          return {
            errors: [{
              pluginName: 'extension-allow-list-plugin',
              text: `Extension not allowed`,
              detail: `Extension for file "${args.path}", imported by "${args.importer}", is not allowed. Permitted extensions are: ${JSON.stringify(allowedExtensions)}.${errorReason}`
            }]
          };
        }

        return undefined;
      });
    }

  };
}

var _default = createExtensionAllowlistPlugin;
exports.default = _default;
//# sourceMappingURL=extensionAllowList.js.map