"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModularTypes = void 0;
exports.default = isModularType;
exports.getModularType = getModularType;
exports.isValidModularRootPackageJson = isValidModularRootPackageJson;
exports.isValidModularType = isValidModularType;
exports.packageTypes = void 0;

var path = _interopRequireWildcard(require("path"));

var fs = _interopRequireWildcard(require("fs-extra"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const packageTypes = ['app', 'view', 'package'];
exports.packageTypes = packageTypes;
const ModularTypes = packageTypes.concat(['root']);
exports.ModularTypes = ModularTypes;

function getModularType(dir) {
  const packageJsonPath = path.join(dir, 'package.json');

  if (fs.existsSync(packageJsonPath)) {
    var _packageJson$modular;

    const packageJson = fs.readJsonSync(packageJsonPath);
    return ((_packageJson$modular = packageJson.modular) === null || _packageJson$modular === void 0 ? void 0 : _packageJson$modular.type) || 'package';
  }
}

function isModularType(dir, type) {
  const packageJsonPath = path.join(dir, 'package.json');

  if (fs.existsSync(packageJsonPath)) {
    var _packageJson$modular2;

    const packageJson = fs.readJsonSync(packageJsonPath);
    return ((_packageJson$modular2 = packageJson.modular) === null || _packageJson$modular2 === void 0 ? void 0 : _packageJson$modular2.type) === type;
  }

  return false;
}

function isValidModularType(dir) {
  return ModularTypes.includes(getModularType(dir));
}

function isValidModularRootPackageJson(dir) {
  const packageJsonPath = path.join(dir, 'package.json');

  if (fs.existsSync(packageJsonPath)) {
    var _packageJson$modular3, _packageJson$workspac;

    const packageJson = fs.readJsonSync(packageJsonPath);
    return ((_packageJson$modular3 = packageJson.modular) === null || _packageJson$modular3 === void 0 ? void 0 : _packageJson$modular3.type) === 'root' && !!packageJson.private && !!(packageJson !== null && packageJson !== void 0 && (_packageJson$workspac = packageJson.workspaces) !== null && _packageJson$workspac !== void 0 && _packageJson$workspac.includes('packages/**'));
  }

  return false;
}
//# sourceMappingURL=isModularType.js.map